
/*******************************
          Flex Box
*******************************/

/* Flex direction  */
 
.l {
  display: -ms-flexbox;
  display: -webkit-flex;
  display: flex;
}

.li {
  display: -ms-inline-flexbox;
  display: -webkit-inline-flex;
  display: inline-flex;
}

.lh {
  @extend .l;

  -ms-flex-direction: row;
  -webkit-flex-direction: row;
  flex-direction: row;
}

.lh-reverse {
  @extend .l;

  -ms-flex-direction: row-reverse;
  -webkit-flex-direction: row-reverse;
  flex-direction: row-reverse;
}

.lv {
  @extend .l;

  -ms-flex-direction: column;
  -webkit-flex-direction: column;
  flex-direction: column;
}

.lv-reverse {
  @extend .l;

  -ms-flex-direction: column-reverse;
  -webkit-flex-direction: column-reverse;
  flex-direction: column-reverse;
}

.wrap {
  -ms-flex-wrap: wrap;
  -webkit-flex-wrap: wrap;
  flex-wrap: wrap;
}

.wrap-reverse {
  -ms-flex-wrap: wrap-reverse;
  -webkit-flex-wrap: wrap-reverse;
  flex-wrap: wrap-reverse;
}

.nowrap {
  -ms-flex-wrap: nowrap;
  -webkit-flex-wrap: nowrap;
  flex-wrap: nowrap;
}

/* Flex grow/shrink/basis  */

.flex-auto {
  -ms-flex: 1 1 auto;
  -webkit-flex: 1 1 auto;
  flex: 1 1 auto;
}

.flex-0 {
  -ms-flex: none;
  -webkit-flex: none;
  flex: none;
}

.flex-shrink {
  -ms-flex: 0 1 auto;
  -webkit-flex: 0 1 auto;
  flex: 0 1 auto;
}

.flex-1 {
  -ms-flex: 1 1 0.000000001px;
  -webkit-flex: 1;
  flex: 1;
  -webkit-flex-basis: 0.000000001px;
  flex-basis: 0.000000001px;
}

.flex-2 {
  -ms-flex: 2;
  -webkit-flex: 2;
  flex: 2;
}

.flex-3 {
  -ms-flex: 3;
  -webkit-flex: 3;
  flex: 3;
}

.flex-4 {
  -ms-flex: 4;
  -webkit-flex: 4;
  flex: 4;
}

.flex-5 {
  -ms-flex: 5;
  -webkit-flex: 5;
  flex: 5;
}

.flex-6 {
  -ms-flex: 6;
  -webkit-flex: 6;
  flex: 6;
}

.flex-7 {
  -ms-flex: 7;
  -webkit-flex: 7;
  flex: 7;
}

.flex-8 {
  -ms-flex: 8;
  -webkit-flex: 8;
  flex: 8;
}

.flex-9 {
  -ms-flex: 9;
  -webkit-flex: 9;
  flex: 9;
}

.flex-10 {
  -ms-flex: 10;
  -webkit-flex: 10;
  flex: 10;
}

.flex-11 {
  -ms-flex: 11;
  -webkit-flex: 11;
  flex: 11;
}

.flex-12 {
  -ms-flex: 12;
  -webkit-flex: 12;
  flex: 12;
}

    /* alignment in cross axis */

.start {
  -ms-flex-align: start;
  -webkit-align-items: flex-start;
  align-items: flex-start;
}

.center {
  -ms-flex-align: center;
  -webkit-align-items: center;
  align-items: center;
}

.end {
  -ms-flex-align: end;
  -webkit-align-items: flex-end;
  align-items: flex-end;
}

.baseline {
  -ms-flex-align: baseline;
  -webkit-align-items: baseline;
  align-items: baseline;
}

.stretch {
  -ms-flex-align: stretch;
  -webkit-align-items: stretch;
  align-items: stretch;
}

/* alignment in main axis */

.start-j {
  -ms-flex-pack: start;
  -webkit-justify-content: flex-start;
  justify-content: flex-start;
}

.center-j {
  -ms-flex-pack: center;
  -webkit-justify-content: center;
  justify-content: center;
}

.end-j {
  -ms-flex-pack: end;
  -webkit-justify-content: flex-end;
  justify-content: flex-end;
}

.around-j {
  -ms-flex-pack: distribute;
  -webkit-justify-content: space-around;
  justify-content: space-around;
}

.j {
  -ms-flex-pack: justify;
  -webkit-justify-content: space-between;
  justify-content: space-between;
}

/* self alignment */

.self-start {
  -ms-align-self: flex-start;
  -webkit-align-self: flex-start;
  align-self: flex-start;
}

.self-center {
  -ms-align-self: center;
  -webkit-align-self: center;
  align-self: center;
}

.self-end {
  -ms-align-self: flex-end;
  -webkit-align-self: flex-end;
  align-self: flex-end;
}

.self-stretch {
  -ms-align-self: stretch;
  -webkit-align-self: stretch;
  align-self: stretch;
}

.self-baseline {
  -ms-align-self: baseline;
  -webkit-align-self: baseline;
  align-self: baseline;
}

/* multi-line alignment in main axis */

.multi-start {
  -ms-flex-line-pack: start;  /* IE10 */
  -ms-align-content: flex-start;
  -webkit-align-content: flex-start;
  align-content: flex-start;
}

.multi-end {
  -ms-flex-line-pack: end;  /* IE10 */
  -ms-align-content: flex-end;
  -webkit-align-content: flex-end;
  align-content: flex-end;
}

.multi-center {
  -ms-flex-line-pack: center;  /* IE10 */
  -ms-align-content: center;
  -webkit-align-content: center;
  align-content: center;
}

.multi-between {
  -ms-flex-line-pack: justify;  /* IE10 */
  -ms-align-content: space-between;
  -webkit-align-content: space-between;
  align-content: space-between;
}

.multi-around {
  -ms-flex-line-pack: distribute;  /* IE10 */
  -ms-align-content: space-around;
  -webkit-align-content: space-around;
  align-content: space-around;
}

.multi-stretch {
  -ms-flex-line-pack: distribute;  /* IE10 */
  -ms-align-content: space-stretch;
  -webkit-align-content: space-stretch;
  align-content: space-stretch;
}

/*******************************
          Flex Grid
*******************************/

.grid {
  @extend .fill;
  @extend .lv;
  padding: 0;
}

.row-1 {
  @extend .lh;
  @extend .flex-1;
}

.row-2 {
  @extend .lh;
  @extend .flex-2;
}

.row-3 {
  @extend .lh;
  @extend .flex-3;
}

.row-4 {
  @extend .lh;
  @extend .flex-4;
}

.row-5 {
  @extend .lh;
  @extend .flex-5;
}

.row-6 {
  @extend .lh;
  @extend .flex-6;
}

.row-7 {
  @extend .lh;
  @extend .flex-7;
}

.row-8 {
  @extend .lh;
  @extend .flex-8;
}

.row-9 {
  @extend .lh;
  @extend .flex-9;
}

.row-10 {
  @extend .lh;
  @extend .flex-10;
}

.row-11 {
  @extend .lh;
  @extend .flex-11;
}

.row-12 {
  @extend .lh;
  @extend .flex-12;
}

.col-1 {
  @extend .flex-1;
}

.col-2 {
  @extend .flex-2;
}

.col-3 {
  @extend .flex-3;
}

.col-4 {
  @extend .flex-4;
}

.col-5 {
  @extend .flex-5;
}

.col-6 {
  @extend .flex-6;
}

.col-7 {
  @extend .flex-7;
}

.col-8 {
  @extend .flex-8;
}

.col-9 {
  @extend .flex-9;
}

.col-10 {
  @extend .flex-10;
}

.col-11 {
  @extend .flex-11;
}

.col-12 {
  @extend .flex-12;
}


/*******************************
          Other Layout
*******************************/

.block {
  display: block;
}

[hidden] {
  display: none !important;
}

.invisible {
  visibility: hidden !important;
}

.relative {
  position: relative;
}

.fit {
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
}

.scroll {
  -webkit-overflow-scrolling: touch;
  overflow: auto;
}

.fullbleed {
  margin: 0;
  height: 100vh;
}

.fill {
  height: 100%;
  width: 100%;
}

.nopadding {
  padding: 0 !important;
}

.clear-float {
  clear:both;
}

.nofloat {
  float: none;
}

.nomargin {
	margin: 0 !important;
}

/* fixed position */

.fixed-top {
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
}

.fixed-right {
  position: fixed;
  top: 0;
  right: 0;
  bottom: 0;
}

.fixed-bottom {
  position: fixed;
  right: 0;
  bottom: 0;
  left: 0;
}

.fixed-left {
  position: fixed;
  top: 0;
  bottom: 0;
  left: 0;
}

/* z-index settigs */

.z-0 {
	z-index: 0;
}

.z-100 {
	z-index: 100;
}

.z-200 {
	z-index: 200;
}

.z-300 {
	z-index: 300;
}

.z-400 {
	z-index: 400;
}

.z-500 {
	z-index: 500;
}

.z-600 {
	z-index: 600;
}

.z-700 {
	z-index: 700;
}

.z-800 {
	z-index: 800;
}

.z-900 {
	z-index: 900;
}

.z-1000 {
	z-index: 1000;
}
